from __future__ import division
import numpy as np
import numpy.random as npr
import scipy.stats as sps
import matplotlib.pyplot as plt

def OKcorall(n): #OKcorall(n) retourne une realisation de V(n)
    a,b=n,n
    while a>0 and b>0:
        if npr.binomial(1,1.0*b/(a+b)):
            a-=1
        else:
            b-=1
    return a+b  
    
    
n=1000 
N=5000 #Nombre de tirates effectues avec n fixe pour estimer la loi de V(n)/n^(3/4)


X=[OKcorall(n)/n**(3/4) for i in xrange(N)] 
plt.close()
plt.figure()
plt.hist(X, normed=True, label="Densite empirique", bins=50) #On regarde si la densite converge
x = np.linspace(min(X), max(X), 100)
f_x =  sqrt(3/pi)*np.exp(-3*(x**4)/16)*x
plt.plot(x, f_x, "r", label="Densite theorique")
plt.legend()
plt.show()

#On regarde ensuite si la fonction de repartition empirique converge en tout point
X_croissant = np.sort(X)  # On trie les donnees en ordre croissant
plt.step(X_croissant, np.arange(N)/N, label="Fonction de repartition empirique") 
plt.legend()
plt.show()
